TYPO3.Flow - Bug # 26107

Status: Resolved Priority: Must have

Author: Christopher Hlubek Category:

Created: 2011-04-19 Assigned To: Christopher Hlubek
Updated: 2011-05-05 Due date:

PHP Version:

Has patch:

Complexity:

Affected Flow version:

Subject: Proxy class builder rebuild classes without AOP on every change

Description

Since classes that don't get a proxy class (if they don't use DI or AOP) are not put inside the cache, the build method of the
ProxyClassBuilder will not find a cache entry inside the classes cache (hasCacheEntryForClass is always false).

So one change of a file still means a lot of time to go through each of these classes and not building an AOP proxy for them on the
next run.

One possibility would be to also cache classes without proxy code (means duplication) or to store information somewhere inside the
object configuration cache (means some effort to keep it in sync if the class eventually introduces DI or AOP).

Related issues:
related to TYPOS.Flow - Bug # 25965: AOP ProxyClassBuilder always detects an ... Resolved 2011-04-14

Associated revisions

Revision 50eff49b - 2011-05-04 21:09 - Christopher Hlubek

[BUGFIX] Caching of unproxied classes in ProxyClassBuilder

Classes that don't get a proxy class will be stored in the object
configuration cache as separate cache entries with a specific class tag.
This way the ProxyClassBuilder can skip these classes if they didn't

change.
Additionally some minor optimizations have been applied to the
ProxyClassBuilder (call-by-reference for large arrays, selection of

aspect classes).

Resolves: #26107
Change-Id: I5f75b00bccc4ef22a5214d4e4c227aalc76e3f72

History

#1 - 2011-05-03 12:36 - Christopher Hlubek
- Status changed from New to Accepted
- Assigned To changed from Robert Lemke to Christopher Hlubek

| found a solution that seems to work. Inside the ProxyClassBuilder each target class that doesn't get a proxy is marked in the object configuration

cache. But we have to cache each unproxied class individually to have separate cache tags.
I'll push a change request soon.

#2 - 2011-05-03 16:58 - Mr. Hudson

Patch set 1 of change 15f75b00bccc4ef22a5214d4e4c227aalc76e3f72 has been pushed to the review server.
It is available at http://review.typo3.org/1888

#3 - 2011-05-03 17:49 - Christopher Hlubek
- Status changed from Accepted to Under Review

#4 - 2011-05-04 21:09 - Mr. Hudson

Patch set 2 of change 15f75b00bccc4ef22a5214d4e4c227aalc76e3f72 has been pushed to the review server.
It is available at http://review.typo3.org/1888

#5 - 2011-05-05 13:00 - Christopher Hlubek
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:50eff49b74ea33b3236781dfbb5269ca9263642d.
